ALTER procedure [dbo].[P_DriverRating] (@R int=1, @UniKey int=null OUTPUT, @RatingName varchar(128)=null,
@Comment varchar(512)=null,
@MaxValue int=null, @PointByPercent int=null, @isEnabled bit=null, 
@Hour int=null, @Driver int=null, @Value int=null,
@IntervalType int=0,@isUseSpecialTask bit=0,@TimeBegin datetime='00:00',@TimeEnd datetime='00:00',
@Task int=null, @Points int=1,
@RatingType int=0, @isVisibleToDriver bit=1, @isValueVisibleToDriver bit=1,
@UserUpdate int=null,
@LPSrc int=null,
@isUseSpecialTaskReset bit=0,@TaskReset int=null,
@DayFromRest int=0,
@isAccumulation bit=0,
@isSaveToJournal bit=0,
@OrderDateType int=0,
@SelectOrder varchar(2000)=null
)
AS
BEGIN
-- =============================================
-- Author:		<Alexey Ivakhin>
-- Create date: <9/11/2010>
-- Update date: <18.09.2017>
-- Description:	< - >
-- =============================================
SET DATEFORMAT dmy;
SET ANSI_NULLS OFF
SET NOCOUNT ON;
DECLARE @Q varchar(4096), @DriverUniKey int, @RatingUniKey int, @OldValue int,@OldValue2 int;
DECLARE @MessageText varchar(256),@MessageText2 varchar(256), @isSaveToJournalRow bit;
	--
	if @R=1
		begin	
		SELECT @MessageText=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_CUSTOM'
				AND LngKey LIKE (SELECT TOP 1 LngMain FROM PROPERTIES);
		SELECT @MessageText2=MessageText FROM LngMessages WHERE MessageName LIKE 'DB_AUTOMATIC'
				AND LngKey LIKE (SELECT TOP 1 LngMain FROM PROPERTIES);
		
		SET @Q='SELECT DR.*,(CASE DR.RatingType WHEN 0 THEN '''+@MessageText+''' ELSE '''+@MessageText2+''' END) as RatingTypeStr, TT.TaskName, DRT.RatingTypeName,TTR.TaskName as TaskNameReset
		FROM DriverRating DR WITH (nolock) LEFT JOIN Tasks TT ON TT.UniKey=DR.Task 
		LEFT JOIN Tasks TTR ON TTR.UniKey=DR.TaskReset 
		LEFT JOIN v_driver_rating_type DRT ON DRT.RatingTypeKey=DR.RatingType
		WHERE 1=1';
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY DR.RatingName ASC';
		exec (@Q);
		end;
	--new
	if @R=2
		begin	
		SELECT @OldValue=MAX(UniKey) FROM DriverRating;
		if(isnull(@OldValue,0)<100) SET @OldValue=101;
			else SET @OldValue=@OldValue+1;
		INSERT INTO DriverRating (RatingName,RatingType,Comment,MaxValue,PointByPercent,isEnabled,[Hour],
			IntervalType,isUseSpecialTask, TimeBegin, TimeEnd, Task,Points, isVisibleToDriver,UniKey, LPSrc,
			isValueVisibleToDriver, isUseSpecialTaskReset,TaskReset,DayFromRest,isAccumulation,isSaveToJournal,
			OrderDateType)
			 VALUES (@RatingName,@RatingType,@Comment,@MaxValue,@PointByPercent,@isEnabled,@Hour,
				@IntervalType,@isUseSpecialTask, @TimeBegin, @TimeEnd, @Task,@Points, @isVisibleToDriver,
				@OldValue,@LPSrc,@isValueVisibleToDriver,@isUseSpecialTaskReset,@TaskReset,@DayFromRest,@isAccumulation,@isSaveToJournal,
				@OrderDateType);
		SET @UniKey=@OldValue;
		EXEC P_driverrating @R=1005;
		end;
	--up
	if @R=3
		begin	
		--  
		if (@UniKey>=100)
			begin
			UPDATE DriverRating SET RatingName=@RatingName,Comment=@Comment
				 WHERE UniKey=@UniKey;
			end;
		SET @OldValue=NULL;		
		SET @OldValue2=NULL;		
		SELECT @OldValue=TASK,@OldValue2=TaskReset FROM DriverRating WHERE UniKey=@UniKey;

		UPDATE DriverRating SET MaxValue=@MaxValue,RatingType=@RatingType,
				IntervalType=@IntervalType, isUseSpecialTask=@isUseSpecialTask, TimeBegin=@TimeBegin, 
				TimeEnd=@TimeEnd, Task=@Task,Points=@Points, isVisibleToDriver=@isVisibleToDriver,
				PointByPercent=@PointByPercent,isEnabled=@isEnabled,[Hour]=@Hour,LPSrc=@LPSrc,
				isValueVisibleToDriver=@isValueVisibleToDriver,isUseSpecialTaskReset=@isUseSpecialTaskReset,
				TaskReset=@TaskReset,DayFromRest=@DayFromRest,isAccumulation=@isAccumulation,
				isSaveToJournal=@isSaveToJournal,OrderDateType=@OrderDateType
				WHERE UniKey=@UniKey;
		--    
		if(@OldValue IS NOT NULL) AND (@Task IS NULL OR @Task!=@OldValue) DELETE FROM Tasks WHERE UniKey=@OldValue;
		if(@OldValue2 IS NOT NULL) AND (@TaskReset IS NULL OR @TaskReset!=@OldValue2) DELETE FROM Tasks WHERE UniKey=@OldValue2;
		return;
		end;
	--del
	if @R=4
		begin	
		--    
		SET @OldValue=NULL;		
		SET @OldValue2=NULL;		
		SELECT @OldValue=TASK,@OldValue2=TaskReset FROM DriverRating WHERE UniKey=@UniKey;
		if(@OldValue IS NOT NULL) DELETE FROM Tasks WHERE UniKey=@OldValue;
		if(@OldValue2 IS NOT NULL) DELETE FROM Tasks WHERE UniKey=@OldValue2;
		DELETE FROM DriverRating WHERE UniKey=@UniKey;
		return;
		end;
	--   DriverRatingS    
	if @R=1005
		begin	
		DECLARE DrvCursor CURSOR FAST_FORWARD FOR
		SELECT UniKey FROM DRIVERS
			FOR READ ONLY;
		OPEN DrvCursor
		FETCH NEXT FROM DrvCursor INTO @DriverUniKey
		WHILE @@FETCH_STATUS = 0
			BEGIN
				--     
				DECLARE RatingCursor CURSOR FAST_FORWARD FOR
				SELECT UniKey FROM DriverRating WITH (nolock);
				OPEN RatingCursor
				FETCH NEXT FROM RatingCursor INTO @RatingUniKey
				WHILE @@FETCH_STATUS = 0
					BEGIN
						--      
						IF NOT EXISTS(SELECT Value FROM DriverRatingS WITH (nolock) WHERE Driver=@DriverUniKey AND DriverRating=@RatingUniKey) 
							INSERT INTO DriverRatingS (Driver,DriverRating) VALUES(@DriverUniKey,@RatingUniKey);
						FETCH NEXT FROM RatingCursor  INTO @RatingUniKey
					END 
				CLOSE RatingCursor
				DEALLOCATE RatingCursor;
			    FETCH NEXT FROM DrvCursor  INTO @DriverUniKey
			END 
		CLOSE DrvCursor
		DEALLOCATE DrvCursor
		end;
	--   1 
	if @R=5
		begin	
		SET @Q='SELECT DR.*,DRS.Value,DRS.DateEnd, [dbo].[GetDriverRatingFinal](DRS.Driver) as RatingFinal,
(CASE DR.RatingType WHEN 0 THEN '''' ELSE '''' END) as RatingTypeStr   FROM DriverRatingS DRS WITH (nolock)
LEFT JOIN DriverRating DR ON DRS.DriverRating=DR.UniKey WHERE DR.isEnabled=1 AND DRS.Driver='+CAST(@Driver as varchar);
		if (@SelectOrder is NOT NULL) SET @Q=@Q+@SelectOrder else SET @Q=@Q+' ORDER BY DR.RatingName ASC';
		exec (@Q);
		end;		
	--up   
	if @R=6
		begin	
		SET @RatingType=NULL;
		SELECT @RatingType=RatingType FROM  DriverRating WITH (nolock) WHERE UniKey=@UniKey;
		--
		if (@RatingType=0)
			begin
			SELECT @OldValue=Value FROM DriverRatingS WHERE DriverRating=@UniKey AND Driver=@Driver;
			SET @OldValue=ISNULL(@OldValue,0);

			UPDATE DriverRatingS SET Value=@Value,DateEnd=@TimeEnd WHERE DriverRating=@UniKey AND Driver=@Driver;
			--   
			if(@OldValue!=@Value)
				INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
					VALUES(@Driver,@UniKey,@UserUpdate,@OldValue,@Value,1);
			end;
		end;
	--     
	if @R=7
		begin	
		EXEC [P_DriverRating] @R=1005;
		DECLARE RatingCursor CURSOR FAST_FORWARD FOR
		SELECT DRS.DriverRating, DR.RatingType,DR.isSaveToJournal,Value 
			FROM DriverRatingS DRS WITH (nolock) LEFT JOIN DriverRating DR
			ON DRS.DriverRating=DR.UniKey WHERE DRS.Driver=@Driver AND DR.isEnabled=1 AND DR.RatingType>0 AND isUseSpecialTask=0
			FOR READ ONLY;
		OPEN RatingCursor
		FETCH NEXT FROM RatingCursor INTO @RatingUniKey,@RatingType,@isSaveToJournalRow,@OldValue;
		WHILE @@FETCH_STATUS = 0
			BEGIN
				--SET @Value=[dbo].[GetDriverRating](@RatingUniKey,@Driver);
				--   
				EXEC [P_GetDriverRating] @RatingUniKey=@RatingUniKey,@Driver=@Driver,@RESULT=@Value OUTPUT;
				UPDATE DriverRatingS SET Value=@Value,LastUpdate=GETDATE() WHERE DriverRating=@RatingUniKey AND Driver=@Driver; 
				
			--   
			if (@isSaveToJournalRow=1) AND (ISNULL(@OldValue,0)!=@Value)
				begin
				INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
					VALUES(@Driver,@RatingUniKey,@UserUpdate,@OldValue,@Value,0);
				end;
				
				FETCH NEXT FROM RatingCursor  INTO @RatingUniKey,@RatingType,@isSaveToJournalRow,@OldValue;
			END 
		CLOSE RatingCursor
		DEALLOCATE RatingCursor;
		end;
	--      
	if @R=8
		begin	
		EXEC [P_DriverRating] @R=1005;
		DECLARE DrvCursor CURSOR FAST_FORWARD FOR
		SELECT UniKey FROM DRIVERS WITH (nolock)
			FOR READ ONLY;
		OPEN DrvCursor
		FETCH NEXT FROM DrvCursor INTO @DriverUniKey
		WHILE @@FETCH_STATUS = 0
			BEGIN
			DECLARE RatingCursor CURSOR FAST_FORWARD FOR
			SELECT  DRS.DriverRating, DR.RatingType,DR.IntervalType,DR.isSaveToJournal,Value 
				FROM DriverRatingS DRS WITH (nolock) LEFT JOIN DriverRating DR
				ON DRS.DriverRating=DR.UniKey 
				WHERE DRS.Driver=@DriverUniKey AND DR.isEnabled=1 AND DR.RatingType>0 AND isUseSpecialTask=0
				FOR READ ONLY;
			OPEN RatingCursor
			FETCH NEXT FROM RatingCursor INTO @RatingUniKey,@RatingType,@IntervalType,@isSaveToJournalRow,@OldValue;
			WHILE @@FETCH_STATUS = 0
				BEGIN
					--   
					if @IntervalType!=4 --  ,    0 
						begin
						EXEC [P_GetDriverRating] @RatingUniKey=@RatingUniKey,@Driver=@DriverUniKey,@RESULT=@Value OUTPUT;
						UPDATE DriverRatingS SET Value=@Value,LastUpdate=GETDATE() WHERE DriverRating=@RatingUniKey AND Driver=@DriverUniKey; 
						
			--   
			if (@isSaveToJournalRow=1) AND (ISNULL(@OldValue,0)!=@Value)
				begin
				INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
					VALUES(@DriverUniKey,@RatingUniKey,@UserUpdate,@OldValue,@Value,0);
				end;
						
						end;
					FETCH NEXT FROM RatingCursor  INTO @RatingUniKey,@RatingType,@IntervalType,@isSaveToJournalRow,@OldValue;
				END 
			CLOSE RatingCursor
			DEALLOCATE RatingCursor;
		    FETCH NEXT FROM DrvCursor  INTO @DriverUniKey
			END 
		CLOSE DrvCursor
		DEALLOCATE DrvCursor
		return;
		end;
	--      
	if @R=9
		begin
		SELECT DD.UNIKEY, dbo.[GetFIO](DD.UNIKEY) as FIO, dbo.[GetCurrentTaxiNum](DD.UNIKEY,GETDATE()) as TAXINUM,
			isnull((SELECT Value FROM DriverRatingS DRS WITH (nolock) WHERE DRS.driver=DD.UNIKEY AND DRS.DriverRating=@UniKey),0) as Value
		  FROM Drivers DD  WITH (nolock) WHERE DD.v_state=0 ORDER BY TAXINUM;
		return;
		end;
	--up        
	if @R=10
		begin	
		SET @RatingType=NULL;
		SELECT @RatingType=RatingType FROM  DriverRating WITH (nolock) WHERE UniKey=@UniKey;
		--
		if (@RatingType=0)
			begin
			SET @DriverUniKey=[dbo].[GetDriverByTaxiNum] (@Driver,GETDATE());
			SELECT @OldValue=Value FROM DriverRatingS WITH (nolock) WHERE DriverRating=@UniKey AND Driver=@DriverUniKey;
			SET @OldValue=ISNULL(@OldValue,0);
			UPDATE DriverRatingS SET Value=@Value 
				WHERE DriverRating=@UniKey AND Driver=@DriverUniKey;
			--   
			if(@OldValue!=@Value)
				INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
					VALUES(@DriverUniKey,@UniKey,@UserUpdate,@OldValue,@Value,1);
			end;
		return;
		end;
	-- 1      
	if @R=11
		begin	
		if object_id('tempdb..#tbl_sp_drv_rating') is not null drop table #tbl_sp_drv_rating;
		create table #tbl_sp_drv_rating ( UniKey int)
		insert #tbl_sp_drv_rating
		SELECT UniKey FROM DRIVERS WITH (nolock) WHERE v_state=0;	-- 
		
		DECLARE DrvCursor11 CURSOR FAST_FORWARD FOR
		SELECT UniKey FROM #tbl_sp_drv_rating		
		OPEN DrvCursor11
		FETCH NEXT FROM DrvCursor11 INTO @DriverUniKey
		WHILE @@FETCH_STATUS = 0
			BEGIN
			SET @OldValue=NULL;
			SELECT @OldValue=Value,@isSaveToJournalRow=DR.isSaveToJournal FROM DriverRatingS DRS WITH (nolock)
				LEFT JOIN DriverRating DR ON DR.UniKey=DRS.DriverRating
				WHERE DRS.Driver=@DriverUniKey AND DRS.DriverRating=@UniKey;
			--   
			EXEC [P_GetDriverRating] @RatingUniKey=@UniKey,@Driver=@DriverUniKey,@RESULT=@Value OUTPUT;
			SET @Value=ISNULL(@Value,0);
			--      
			--IF NOT EXISTS(SELECT Value FROM DriverRatingS WHERE Driver=@DriverUniKey AND DriverRating=@UniKey) 
			IF @OldValue IS NULL
				INSERT INTO DriverRatingS (Driver,DriverRating,Value,LastUpdate) VALUES(@DriverUniKey,@UniKey,@Value,GETDATE());
				else
				UPDATE DriverRatingS SET Value=@Value WHERE DriverRating=@UniKey AND Driver=@DriverUniKey; 
			--   
			if (@isSaveToJournalRow=1) AND (ISNULL(@OldValue,0)!=@Value)
				begin
				INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
					VALUES(@DriverUniKey,@UniKey,NULL,@OldValue,@Value,0);
				end;
		    FETCH NEXT FROM DrvCursor11  INTO @DriverUniKey
			END 
		CLOSE DrvCursor11
		DEALLOCATE DrvCursor11
		return;
		end;
	-- 1    
	if @R=12
		begin	
		DECLARE RatingCursor CURSOR FAST_FORWARD FOR
		SELECT DRS.DriverRating, DRS.Driver FROM DriverRatingS DRS WITH (nolock) WHERE 
			DriverRating=@UniKey AND Value!=0
			FOR READ ONLY;
		OPEN RatingCursor
		FETCH NEXT FROM RatingCursor INTO @RatingUniKey,@DriverUniKey;
		WHILE @@FETCH_STATUS = 0
			BEGIN
				--   
				if(@UserUpdate IS NOT NULL)
					begin
					SELECT @OldValue=Value FROM DriverRatingS WHERE DriverRating=@RatingUniKey AND Driver=@DriverUniKey;
					INSERT INTO DriverRatingJournal (Driver,Rating,UserUpdate,OldValue,NewValue,isManual) 
						VALUES(@DriverUniKey,@RatingUniKey,@UserUpdate,@OldValue,0,1);				
					end;
				UPDATE DriverRatingS SET Value=0,LastUpdate=GETDATE() WHERE DriverRating=@RatingUniKey AND Driver=@DriverUniKey;
				FETCH NEXT FROM RatingCursor  INTO @RatingUniKey,@DriverUniKey;
			END 
		CLOSE RatingCursor
		DEALLOCATE RatingCursor;
		return;
		end;		
	--   1    
	if @R=13
		begin	
		SELECT DR.RatingName,DRS.Value FROM DriverRatingS DRS WITH (nolock)
		LEFT JOIN DriverRating DR ON DRS.DriverRating=DR.UniKey WHERE DR.isEnabled=1 AND DR.isVisibleToDriver=1 AND DRS.Driver=@Driver
		 ORDER BY DR.RatingName ASC
		return;
		end;		
	--     
	if @R=14
		begin	
		SELECT DRJ.*, uu.FIO, DR.RatingName FROM DriverRatingJournal DRJ 
			LEFT JOIN USERS uu ON uu.UniKey=DRJ.UserUpdate
			LEFT JOIN DriverRating DR ON DR.UniKey=DRJ.Rating
			WHERE DRJ.Driver=@Driver ORDER BY DRJ.DateUpdate DESC;
		return;
		end;		

END
